import * as React from 'react';
import { pie, arc, interpolateRgb, centroid } from 'd3';

export const Slice = ({
  data,
  outerRadius,
  innerRadius
}) => {
  let arc = d3
    .arc()
    .innerRadius(0)
    .outerRadius(outerRadius);
  
  const plotVariable = d => d.pop;
  const textVariable = d => d.name;
  const plotData = data.map(d => plotVariable(d))
  const textData = data.map(d => textVariable(d))
  let pie = d3.pie()(plotData);

  let interpolate = d3.interpolateRgb('#bc3358', '#eaaf79');
  return pie.map((slice, index) => {
    let sliceColor = interpolate(index / (pie.length - 1));
    console.log(arc.centroid(slice))
    return (
      <>
        <path d={arc(slice)} fill={sliceColor} />
        <text
          className="pie-slice"
          transform={`translate(${arc.centroid(slice)})`}
          text-anchor="middle"
        >
          {textData[index]}
        </text>
      </>
    );
  });
};
